﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using Microsoft.WindowsAzure;
using Microsoft.WindowsAzure.StorageClient;
using Microsoft.WindowsAzure.ServiceRuntime;

namespace WebCapture_WebRole.Controllers
{
    [HandleError]
    public class HomeController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        [HttpPost]
        public JsonResult Submit(string url)
        {
            try
            {
                url = new Uri(url).AbsoluteUri;
            }
            catch (UriFormatException)
            {
                url = new Uri("http://" + url).AbsoluteUri;
            }
            var guid = Guid.NewGuid().ToString();
            CloudStorageAccount.Parse(RoleEnvironment.GetConfigurationSettingValue("DataConnectionString")).CreateCloudQueueClient().GetQueueReference("incoming").AddMessage(new CloudQueueMessage(string.Format("{0}/{1}", guid, url)));
            return Json(new { guid = guid });
        }

        [HttpPost]
        public JsonResult CheckStatus(string guid)
        {
            try
            {
                var blob = CloudStorageAccount.Parse(RoleEnvironment.GetConfigurationSettingValue("DataConnectionString")).CreateCloudBlobClient().GetBlobReference("output/" + guid);
                blob.FetchAttributes();
                return Json(blob.Uri.AbsoluteUri);
            }
            catch (StorageClientException e)
            {
                if (e.ErrorCode == StorageErrorCode.ResourceNotFound)
                {
                    return Json(false);
                }
                else
                {
                    throw;
                }
            }
        }
    }
}